//+------------------------------------------------------------------+
//|                                          Engulfing Bar Alert.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_color2 Violet


extern string TimeFrame       = "Current time frame";
extern bool alertsOn           = false;
extern bool alertsSound        = false;
extern bool alertsMessage      = true;
extern bool alertsNotification = false;
extern bool alertsEmail        = false;

//---- buffers
double Up[],Dn[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+

int init()
  {
   SetIndexBuffer(0,Up);
   SetIndexBuffer(1,Dn);
   
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   
         timeFrame         = stringToTimeFrame(TimeFrame);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+

int start() {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1); for (;limit<Bars-1;limit++) { if (Up[limit]!=EMPTY_VALUE || Dn[limit]!=EMPTY_VALUE) break; }
           if (returnBars) { Up[0] = limit+1; return(0); }
           if (timeFrame!=Period())
           {
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                  int y = iBarShift(NULL,timeFrame,Time[i]);               
                  int x = iBarShift(NULL,timeFrame,Time[i+1]);               
                  Up[i] = EMPTY_VALUE;
                  Dn[i] = EMPTY_VALUE;
                  if(x!=y)
                  {
                     Up[i] = iCustom(NULL,timeFrame,indicatorFileName,"",alertsOn,alertsSound,alertsMessage,alertsNotification,alertsEmail,0,y);
                     Dn[i] = iCustom(NULL,timeFrame,indicatorFileName,"",alertsOn,alertsSound,alertsMessage,alertsNotification,alertsEmail,1,y);
                  }                     
               }
               return(0);
            }               

   //
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) 
   {
      int    counter  = i;
      double Range    = 0;
      double AvgRange = 0;
      for (counter=i ;counter<=i+2;counter++)
      {
         AvgRange=AvgRange+MathAbs(High[counter]-Low[counter]);
      }
      Range=AvgRange/10;
      
        
        Up[i+1] = EMPTY_VALUE;
        Dn[i+1] = EMPTY_VALUE;
	     //  UP
	     if (Close[i+1]>Open[i+1]&&Close[i+2]<Open[i+2]&&Close[i+1]>Open[i+2]&&Open[i+1]<=Close[i+2])
           {
          	Up[i+1]=Low[i+1]-Range*1.5;
           }
		                                                         
           
        // DOWN
        if (Close[i+1]<Open[i+1]&&Close[i+2]>Open[i+2]&&Close[i+1]<Open[i+2]&&Open[i+1]>=Close[i+2])
           {                               
		      Dn[i+1]=High[i+1]+Range*1.5;
		     } 		          
           
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
         if (Up[1] != EMPTY_VALUE) doAlert(alertType1,alertTime1,"Engulfing bar signal up");
         if (Dn[1] != EMPTY_VALUE) doAlert(alertType1,alertTime1,"Engulfing bar signal Down");
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+"  "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol(),"Engulfing bar"),message);
          if (alertsNotification) SendNotification(StringConcatenate(Symbol(),"Engulfing bar "+message));
          if (alertsSound)        PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}